PGraphics sun;
PGraphics floor;

int cols, rows;
int scl = 20;
int w = 2500;
int h = 1600;

float flying = 0;

float[][] terrain;

int num = 45; 
float [] y = new float[num];
float sW;

void setup() {
  size(900, 900, P3D); //3D canvas
 
  sun = createGraphics(width, height);
  floor = createGraphics(width, height, P3D);
  for (int n=0; n<num; n++) {
  y[n] = height/num*n; //set number of lines for the sun
 }
  sW = height/num/2; 
  cols = w / scl;
  rows = h/ scl;
  terrain = new float[cols][rows];
}


void draw() {

  //sun
  //credit: thedotisblack
  //from: https://www.youtube.com/watch?v=TOm5wKmn9yw&ab
  
  sun.beginDraw();
  background(#300350);

 for (int n=0; n<num; n++) {
 // float alpha = map(y[n], 0, height, 0, 255);
  float alpha = map(0, y[n], width, y[n], 255); //gradient mask on the sun
  sun.stroke(#F9AC53, alpha); 
  sun.strokeWeight(sW); 
  sun.line(0, y[n], width, y[n]); 
  
  
  y[n] += 0.3; //speed of sun
  if (y[n]>height) y[n] = 0;
 }
 
 sun.stroke(#300350); 
 sun.strokeWeight(height/3); 
 sun.noFill();
 sun.ellipse(width/2, height/2, height+height/6, height+height/6); //mask
 
 //sun.endDraw();
 
  //floor
  // credit: Daniel Shiffman
  // http://codingtra.in
  // http://patreon.com/codingtrain
  // Code for: https://youtu.be/IKB1hWWedMk
  
  floor.beginDraw();
  flying -= 0.05;   //floor speed

  float yoff = flying;
  for (int y = 0; y < rows; y++) {
    float xoff = 0;
    for (int x = 0; x < cols; x++) {
      terrain[x][y] = map(noise(xoff, yoff), 0, 1, -100, 100); //terrain lift
      xoff += 0.2;
    }
    yoff += 0.2;
  }
  floor.fill(#300350);
  floor.stroke(#F62E97);
  floor.translate(width/2, height/2+500);
  floor.rotateX(PI/3); //how flat the floor is
  floor.translate(-w/2, -h/2); //where the floor is relative to the canvas
  for (int y = 0; y < rows-1; y++) {
    floor.beginShape(TRIANGLE_STRIP);
    for (int x = 0; x < cols; x++) {
      floor.vertex(x*scl, y*scl, terrain[x][y]);
      floor.vertex(x*scl, (y+1)*scl, terrain[x][y+1]);
    }
    floor.endShape();
  }
  floor.endDraw();
  
  image(sun, 0, 0);
  image(floor, 0, 0); //layering
}
